From 2d4b9b69f275680351b0497c0b7c2d3a86da8e18 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Fri, 3 Feb 2012 10:06:17 -0600
Subject: Exploring dynamic loading

---
 grade/report/quick_edit/classes/lib.php       |   23 ++++++++++++++++++++++-
 grade/report/quick_edit/index.php             |    6 +++---
 grade/report/quick_edit/lib.php               |   17 +++++++++++++++--
 grade/report/quick_edit/screens/grade/lib.php |   18 ++++++++++++++++++
 4 files changed, 58 insertions(+), 6 deletions(-)

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index beaed35..54c1171 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -1,4 +1,25 @@
 <?php
 
-abstract class quit_edit_screen {
+abstract class quick_edit_screen {
+    var $courseid;
+
+    var $itemid;
+
+    var $groupid;
+
+    var $context;
+
+    function __construct($courseid, $itemid, $groupid = null) {
+        $this->courseid = $courseid;
+        $this->itemid = $itemid;
+        $this->groupid = $groupid;
+
+        $this->context = get_context_instance(CONTEXT_COURSE, $this->courseid);
+
+        $this->init();
+    }
+
+    public abstract function init();
+
+    public abstract function html();
 }
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 47e73fe..60121b0 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -28,7 +28,7 @@ require_once $CFG->dirroot.'/grade/lib.php';
 require_once $CFG->dirroot.'/grade/report/quick_edit/lib.php';
 
 $courseid = required_param('id', PARAM_INT);
-$itemtype = optional_param('item', 'grade', PARAM_TEXT);
+$itemtype = optional_param('item', 'select', PARAM_TEXT);
 $itemid = optional_param('itemid', 0, PARAM_INT);
 $groupid  = optional_param('group', null, PARAM_INT);
 
@@ -43,7 +43,7 @@ if (!$course = $DB->get_record('course', array('id' => $courseid))) {
     print_error('nocourseid');
 }
 
-if (!in_array($itemtype, grade_report_quick_edit::valid_types())) {
+if (!in_array($itemtype, grade_report_quick_edit::valid_screens())) {
     print_error('notvalid', 'gradereport_quick_edit', '', $itemtype);
 }
 
@@ -79,7 +79,7 @@ $PAGE->set_context($context);
 print_grade_page_head($course->id, 'report', 'quick_edit', $reportname, false);
 
 $report = new grade_report_quick_edit(
-    $courseid, $gpr, $context, $itemtype, $itemid, $group
+    $courseid, $gpr, $context, $itemtype, $itemid, $groupid
 );
 
 echo $report->output();
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index 254b9f4..30414c7 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -23,11 +23,11 @@
 ///////////////////////////////////////////////////////////////////////////
 
 require_once($CFG->dirroot . '/grade/report/lib.php');
-require_once($CFG->libdir.'/tablelib.php');
+require_once($CFG->dirroot . '/grade/report/quick_edit/classes/lib.php');
 
 class grade_report_quick_edit extends grade_report {
 
-    public static function valid_types() {
+    public static function valid_screens() {
         $screendir = dirname(__FILE__) . '/screens';
 
         $is_valid = function($filename) use ($screendir) {
@@ -48,6 +48,14 @@ class grade_report_quick_edit extends grade_report {
         return array_filter(scandir($screendir), $is_valid);
     }
 
+    public static function classname($screen) {
+        $screendir = dirname(__FILE__) . '/screens/' . $screen;
+
+        require_once $screendir . '/lib.php';
+
+        return 'quick_edit_' . $screen;
+    }
+
     function process_data($data) {
     }
 
@@ -60,8 +68,13 @@ class grade_report_quick_edit extends grade_report {
 
     function __construct($courseid, $gpr, $context, $itemtype, $itemid, $groupid=null) {
         parent::__construct($courseid, $gpr, $context);
+
+        $class = self::classname($itemtype);
+
+        $this->screen = new $class($courseid, $itemid, $groupid);
     }
 
     function output() {
+        return $this->screen->html();
     }
 }
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index 976ae86..c75d3bc 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -1,4 +1,22 @@
 <?php
 
 class quick_edit_grade extends quick_edit_screen {
+
+    public function init() {
+        $add = $this->itemid ?
+            array('id' => $this->itemid) :
+            array('itemtype' => 'manual');
+
+        $params = array('courseid' => $this->courseid) + $add;
+
+        $roleids = explode(',', get_config('moodle', 'gradebookroles'));
+
+        $this->item = grade_item::fetch($params);
+
+        $this->users = get_role_users($roleids, $this->context, false, '',
+            'u.lastname, u.firstname', null, $this->groupid);
+    }
+
+    public function html() {
+    }
 }
-- 
1.7.1


